select
    an.numero as "Cow number"
    , an.brincoeletronico as "Number Tag"
    , null  as "EID (RFID)"
    , null  as "Group number"
    , (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 and re.data <= ult_parto.data) as "Lactation Number"
    , an.dtnascimento  as "Birth Date "
    , ult_parto.data as "Calving Date "
    , null  as "Milking Effectr"
    , null  as "Sort Area"
    , (select count(*) from reproducao re where re.cdanimal = ult_parto.cdanimal and re.cdtiporeproducao in (1,2,3)
        and re.data > ult_parto.data) as "Insemination Number"
    , (case when (((ultev.cio in (1,2,3)) and (ultev.cdtiporeproducao = 4)) or (ultev.diagnostico = 'N')) then '-'
            when (ultev.diagnostico = 'P') then '+' else null end) as "Pregnacy Test Result"
    , (case when (((ultev.cio in (1,2,3)) and (ultev.cdtiporeproducao = 4)) or (ultev.diagnostico = 'N')) then ultev.data
            when (ultev.diagnostico = 'P') then ultev.data else null end) as "Pregnancy Test Date"
    , lac.dtfim as "Dry off date"
    , null  as "Sire Choice 1"
    , null  as "Sire Choice 2"
    , null  as "Do Not Breed "
from
    animal an
    join reproducao ult_parto on ult_parto.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc)
    left join reproducao ultev on ultev.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ult_parto.cdanimal and re.data > ult_parto.data and
                ((re.cdtiporeproducao in (1,2,3)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data desc)
    left join lactacao lac on lac.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = ult_parto.cdanimal
                order by re.dtinicio desc)
where an.dtbaixa is null
order by
    an.numordenado